"""
    Funds API For Digital Portals

    Search for mutual funds and ETFs using one single consolidated API, including a criteria-based screener. The API provides also base data, key figures, and holdings.  A separate endpoint returns the possible values and value range for the parameters that the endpoint /fund/notation/screener/search accepts: Application developers can request the values and value range only for a restricted set of notations that match predefined parameters. This functionality may be used to pre-fill the values and value ranges of the parameters of the /fund/notation/screener/search endpoint so that performing a search always leads to a non-empty set of notations.  This API is fully integrated with the corresponding Quotes API, allowing access to detailed price and performance information of instruments, as well as basic security identifier cross-reference. For direct access to price histories, please refer to the Time Series API for Digital Portals.  Similar criteria based screener APIs exist for equity instruments and securitized derivatives: See the Stocks API and the Securitized Derivatives API for details.  # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FundsAPIforDigitalPortals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FundsAPIforDigitalPortals.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.FundsAPIforDigitalPortals.model.attributes_member import AttributesMember
    from fds.sdk.FundsAPIforDigitalPortals.model.fund_notation_screener_search_meta_pagination import FundNotationScreenerSearchMetaPagination
    from fds.sdk.FundsAPIforDigitalPortals.model.language_member import LanguageMember
    globals()['AttributesMember'] = AttributesMember
    globals()['FundNotationScreenerSearchMetaPagination'] = FundNotationScreenerSearchMetaPagination
    globals()['LanguageMember'] = LanguageMember


class FundNotationScreenerSearchMeta(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('sort',): {
            'CURRENCY.CODE': "currency.code",
            '-CURRENCY.CODE': "-currency.code",
            'INSTRUMENT.NAME': "instrument.name",
            '-INSTRUMENT.NAME': "-instrument.name",
            'INSTRUMENT.SHORTNAME': "instrument.shortName",
            '-INSTRUMENT.SHORTNAME': "-instrument.shortName",
            'FUND.ETF': "fund.etf",
            '-FUND.ETF': "-fund.etf",
            'FUND.CURRENCY.ISOCODE': "fund.currency.isoCode",
            '-FUND.CURRENCY.ISOCODE': "-fund.currency.isoCode",
            'FUND.DOMICILE.NAME': "fund.domicile.name",
            '-FUND.DOMICILE.NAME': "-fund.domicile.name",
            'FUND.HOLDINGTYPE.NAME': "fund.holdingType.name",
            '-FUND.HOLDINGTYPE.NAME': "-fund.holdingType.name",
            'FUND.COUNTRYDEVELOPMENT.NAME': "fund.countryDevelopment.name",
            '-FUND.COUNTRYDEVELOPMENT.NAME': "-fund.countryDevelopment.name",
            'FUND.REGIONALEXPOSURE.BROAD.NAME': "fund.regionalExposure.broad.name",
            '-FUND.REGIONALEXPOSURE.BROAD.NAME': "-fund.regionalExposure.broad.name",
            'FUND.REGIONALEXPOSURE.SPECIFIC.NAME': "fund.regionalExposure.specific.name",
            '-FUND.REGIONALEXPOSURE.SPECIFIC.NAME': "-fund.regionalExposure.specific.name",
            'FUND.STRATEGY.LEVEL1.NAME': "fund.strategy.level1.name",
            '-FUND.STRATEGY.LEVEL1.NAME': "-fund.strategy.level1.name",
            'FUND.STRATEGY.LEVEL2.NAME': "fund.strategy.level2.name",
            '-FUND.STRATEGY.LEVEL2.NAME': "-fund.strategy.level2.name",
            'FUND.STRATEGY.LEVEL3.NAME': "fund.strategy.level3.name",
            '-FUND.STRATEGY.LEVEL3.NAME': "-fund.strategy.level3.name",
            'FUND.INDUSTRY.NAME': "fund.industry.name",
            '-FUND.INDUSTRY.NAME': "-fund.industry.name",
            'FUND.SRRI.GRADE': "fund.srri.grade",
            '-FUND.SRRI.GRADE': "-fund.srri.grade",
            'FUND.ISSUER.NAME': "fund.issuer.name",
            '-FUND.ISSUER.NAME': "-fund.issuer.name",
            'FUND.ISSUER.COUNTRY.NAME': "fund.issuer.country.name",
            '-FUND.ISSUER.COUNTRY.NAME': "-fund.issuer.country.name",
            'FUND.ASSETSUNDERMANAGEMENT': "fund.assetsUnderManagement",
            '-FUND.ASSETSUNDERMANAGEMENT': "-fund.assetsUnderManagement",
            'SHARECLASS.LIFECYCLE.ISSUE': "shareClass.lifeCycle.issue",
            '-SHARECLASS.LIFECYCLE.ISSUE': "-shareClass.lifeCycle.issue",
            'SHARECLASS.MINIMUMINVESTMENT.INITIAL': "shareClass.minimumInvestment.initial",
            '-SHARECLASS.MINIMUMINVESTMENT.INITIAL': "-shareClass.minimumInvestment.initial",
            'SHARECLASS.MINIMUMINVESTMENT.SUBSEQUENT': "shareClass.minimumInvestment.subsequent",
            '-SHARECLASS.MINIMUMINVESTMENT.SUBSEQUENT': "-shareClass.minimumInvestment.subsequent",
            'SHARECLASS.ASSETSUNDERMANAGEMENT': "shareClass.assetsUnderManagement",
            '-SHARECLASS.ASSETSUNDERMANAGEMENT': "-shareClass.assetsUnderManagement",
            'SHARECLASS.FEE.ONGOING.CURRENT': "shareClass.fee.ongoing.current",
            '-SHARECLASS.FEE.ONGOING.CURRENT': "-shareClass.fee.ongoing.current",
            'SHARECLASS.FEE.ALLIN.CURRENT': "shareClass.fee.allIn.current",
            '-SHARECLASS.FEE.ALLIN.CURRENT': "-shareClass.fee.allIn.current",
            'SHARECLASS.FEE.PERFORMANCE.CURRENT': "shareClass.fee.performance.current",
            '-SHARECLASS.FEE.PERFORMANCE.CURRENT': "-shareClass.fee.performance.current",
            'SHARECLASS.FEE.MANAGEMENT.CURRENT': "shareClass.fee.management.current",
            '-SHARECLASS.FEE.MANAGEMENT.CURRENT': "-shareClass.fee.management.current",
            'SHARECLASS.FEE.INITIAL.MINIMUM': "shareClass.fee.initial.minimum",
            '-SHARECLASS.FEE.INITIAL.MINIMUM': "-shareClass.fee.initial.minimum",
            'SHARECLASS.FEE.INITIAL.CURRENT': "shareClass.fee.initial.current",
            '-SHARECLASS.FEE.INITIAL.CURRENT': "-shareClass.fee.initial.current",
            'SHARECLASS.FEE.INITIAL.MAXIMUM': "shareClass.fee.initial.maximum",
            '-SHARECLASS.FEE.INITIAL.MAXIMUM': "-shareClass.fee.initial.maximum",
            'SHARECLASS.FEE.DISTRIBUTION.MAXIMUM': "shareClass.fee.distribution.maximum",
            '-SHARECLASS.FEE.DISTRIBUTION.MAXIMUM': "-shareClass.fee.distribution.maximum",
            'SHARECLASS.FEE.HANDLING.MAXIMUM': "shareClass.fee.handling.maximum",
            '-SHARECLASS.FEE.HANDLING.MAXIMUM': "-shareClass.fee.handling.maximum",
            'SHARECLASS.FEE.REDEMPTION.CURRENT': "shareClass.fee.redemption.current",
            '-SHARECLASS.FEE.REDEMPTION.CURRENT': "-shareClass.fee.redemption.current",
            'SHARECLASS.FEE.REDEMPTION.MAXIMUM': "shareClass.fee.redemption.maximum",
            '-SHARECLASS.FEE.REDEMPTION.MAXIMUM': "-shareClass.fee.redemption.maximum",
            'SHARECLASS.FEE.CUSTODIANBANK.CURRENT': "shareClass.fee.custodianBank.current",
            '-SHARECLASS.FEE.CUSTODIANBANK.CURRENT': "-shareClass.fee.custodianBank.current",
            'SHARECLASS.FEE.12B.CURRENT': "shareClass.fee.12b.current",
            '-SHARECLASS.FEE.12B.CURRENT': "-shareClass.fee.12b.current",
            'SHARECLASS.FEE.SWITCHING.CURRENT': "shareClass.fee.switching.current",
            '-SHARECLASS.FEE.SWITCHING.CURRENT': "-shareClass.fee.switching.current",
            'PERFORMANCE.ENDOFDAY.DAY1': "performance.endOfDay.day1",
            '-PERFORMANCE.ENDOFDAY.DAY1': "-performance.endOfDay.day1",
            'PERFORMANCE.ENDOFDAY.WEEK1': "performance.endOfDay.week1",
            '-PERFORMANCE.ENDOFDAY.WEEK1': "-performance.endOfDay.week1",
            'PERFORMANCE.ENDOFDAY.MONTH1': "performance.endOfDay.month1",
            '-PERFORMANCE.ENDOFDAY.MONTH1': "-performance.endOfDay.month1",
            'PERFORMANCE.ENDOFDAY.MONTHS3': "performance.endOfDay.months3",
            '-PERFORMANCE.ENDOFDAY.MONTHS3': "-performance.endOfDay.months3",
            'PERFORMANCE.ENDOFDAY.MONTHS6': "performance.endOfDay.months6",
            '-PERFORMANCE.ENDOFDAY.MONTHS6': "-performance.endOfDay.months6",
            'PERFORMANCE.ENDOFDAY.YEAR1': "performance.endOfDay.year1",
            '-PERFORMANCE.ENDOFDAY.YEAR1': "-performance.endOfDay.year1",
            'PERFORMANCE.ENDOFDAY.YEARS3': "performance.endOfDay.years3",
            '-PERFORMANCE.ENDOFDAY.YEARS3': "-performance.endOfDay.years3",
            'PERFORMANCE.ENDOFDAY.YEARS5': "performance.endOfDay.years5",
            '-PERFORMANCE.ENDOFDAY.YEARS5': "-performance.endOfDay.years5",
            'PERFORMANCE.ENDOFDAY.YEARTODATE': "performance.endOfDay.yearToDate",
            '-PERFORMANCE.ENDOFDAY.YEARTODATE': "-performance.endOfDay.yearToDate",
        },
    }

    validations = {
        ('sort',): {
            'max_items': 10,
        },
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'attributes': (AttributesMember,),  # noqa: E501
            'language': (LanguageMember,),  # noqa: E501
            'sort': ([str],),  # noqa: E501
            'pagination': (FundNotationScreenerSearchMetaPagination,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'attributes': 'attributes',  # noqa: E501
        'language': 'language',  # noqa: E501
        'sort': 'sort',  # noqa: E501
        'pagination': 'pagination',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """FundNotationScreenerSearchMeta - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            attributes (AttributesMember): [optional]  # noqa: E501
            language (LanguageMember): [optional]  # noqa: E501
            sort ([str]): Sortable attributes. The sort order is ascending unless it is prefixed with a minus sign, in which case it is descending. A list of at most 10 (possibly prefixed) attribute name(s) is allowed.. [optional]  # noqa: E501
            pagination (FundNotationScreenerSearchMetaPagination): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """FundNotationScreenerSearchMeta - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            attributes (AttributesMember): [optional]  # noqa: E501
            language (LanguageMember): [optional]  # noqa: E501
            sort ([str]): Sortable attributes. The sort order is ascending unless it is prefixed with a minus sign, in which case it is descending. A list of at most 10 (possibly prefixed) attribute name(s) is allowed.. [optional]  # noqa: E501
            pagination (FundNotationScreenerSearchMetaPagination): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
