"""
    Funds API For Digital Portals

    Search for mutual funds and ETFs using one single consolidated API, including a criteria-based screener. The API provides also base data, key figures, and holdings.  A separate endpoint returns the possible values and value range for the parameters that the endpoint /fund/notation/screener/search accepts: Application developers can request the values and value range only for a restricted set of notations that match predefined parameters. This functionality may be used to pre-fill the values and value ranges of the parameters of the /fund/notation/screener/search endpoint so that performing a search always leads to a non-empty set of notations.  This API is fully integrated with the corresponding Quotes API, allowing access to detailed price and performance information of instruments, as well as basic security identifier cross-reference. For direct access to price histories, please refer to the Time Series API for Digital Portals.  Similar criteria based screener APIs exist for equity instruments and securitized derivatives: See the Stocks API and the Securitized Derivatives API for details.  # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FundsAPIforDigitalPortals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FundsAPIforDigitalPortals.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_compliance import InlineResponse2004FundCompliance
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_country_development import InlineResponse2004FundCountryDevelopment
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_currency import InlineResponse2004FundCurrency
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_domicile import InlineResponse2004FundDomicile
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_holding_type import InlineResponse2004FundHoldingType
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_industry import InlineResponse2004FundIndustry
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_issuer import InlineResponse2004FundIssuer
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_regional_exposure import InlineResponse2004FundRegionalExposure
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_srri import InlineResponse2004FundSrri
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2004_fund_strategy import InlineResponse2004FundStrategy
    globals()['InlineResponse2004FundCompliance'] = InlineResponse2004FundCompliance
    globals()['InlineResponse2004FundCountryDevelopment'] = InlineResponse2004FundCountryDevelopment
    globals()['InlineResponse2004FundCurrency'] = InlineResponse2004FundCurrency
    globals()['InlineResponse2004FundDomicile'] = InlineResponse2004FundDomicile
    globals()['InlineResponse2004FundHoldingType'] = InlineResponse2004FundHoldingType
    globals()['InlineResponse2004FundIndustry'] = InlineResponse2004FundIndustry
    globals()['InlineResponse2004FundIssuer'] = InlineResponse2004FundIssuer
    globals()['InlineResponse2004FundRegionalExposure'] = InlineResponse2004FundRegionalExposure
    globals()['InlineResponse2004FundSrri'] = InlineResponse2004FundSrri
    globals()['InlineResponse2004FundStrategy'] = InlineResponse2004FundStrategy


class InlineResponse2004Fund(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'id': (float,),  # noqa: E501
            'name': (str,),  # noqa: E501
            'etf': (bool,),  # noqa: E501
            'currency': (InlineResponse2004FundCurrency,),  # noqa: E501
            'domicile': (InlineResponse2004FundDomicile,),  # noqa: E501
            'holding_type': (InlineResponse2004FundHoldingType,),  # noqa: E501
            'country_development': (InlineResponse2004FundCountryDevelopment,),  # noqa: E501
            'regional_exposure': (InlineResponse2004FundRegionalExposure,),  # noqa: E501
            'strategy': (InlineResponse2004FundStrategy,),  # noqa: E501
            'industry': (InlineResponse2004FundIndustry,),  # noqa: E501
            'srri': (InlineResponse2004FundSrri,),  # noqa: E501
            'issuer': (InlineResponse2004FundIssuer,),  # noqa: E501
            'assets_under_management': (float,),  # noqa: E501
            'compliance': ([InlineResponse2004FundCompliance],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'id': 'id',  # noqa: E501
        'name': 'name',  # noqa: E501
        'etf': 'etf',  # noqa: E501
        'currency': 'currency',  # noqa: E501
        'domicile': 'domicile',  # noqa: E501
        'holding_type': 'holdingType',  # noqa: E501
        'country_development': 'countryDevelopment',  # noqa: E501
        'regional_exposure': 'regionalExposure',  # noqa: E501
        'strategy': 'strategy',  # noqa: E501
        'industry': 'industry',  # noqa: E501
        'srri': 'srri',  # noqa: E501
        'issuer': 'issuer',  # noqa: E501
        'assets_under_management': 'assetsUnderManagement',  # noqa: E501
        'compliance': 'compliance',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """InlineResponse2004Fund - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (float): Identifier of the fund.. [optional]  # noqa: E501
            name (str): Name of the fund.. [optional]  # noqa: E501
            etf (bool): If `true`, the fund is an ETF.. [optional]  # noqa: E501
            currency (InlineResponse2004FundCurrency): [optional]  # noqa: E501
            domicile (InlineResponse2004FundDomicile): [optional]  # noqa: E501
            holding_type (InlineResponse2004FundHoldingType): [optional]  # noqa: E501
            country_development (InlineResponse2004FundCountryDevelopment): [optional]  # noqa: E501
            regional_exposure (InlineResponse2004FundRegionalExposure): [optional]  # noqa: E501
            strategy (InlineResponse2004FundStrategy): [optional]  # noqa: E501
            industry (InlineResponse2004FundIndustry): [optional]  # noqa: E501
            srri (InlineResponse2004FundSrri): [optional]  # noqa: E501
            issuer (InlineResponse2004FundIssuer): [optional]  # noqa: E501
            assets_under_management (float): Assets under management (AUM).. [optional]  # noqa: E501
            compliance ([InlineResponse2004FundCompliance]): List of compliance properties to which the fund is compliant. See endpoint `/legalEntity/complianceProperty/list` for possible values.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """InlineResponse2004Fund - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            id (float): Identifier of the fund.. [optional]  # noqa: E501
            name (str): Name of the fund.. [optional]  # noqa: E501
            etf (bool): If `true`, the fund is an ETF.. [optional]  # noqa: E501
            currency (InlineResponse2004FundCurrency): [optional]  # noqa: E501
            domicile (InlineResponse2004FundDomicile): [optional]  # noqa: E501
            holding_type (InlineResponse2004FundHoldingType): [optional]  # noqa: E501
            country_development (InlineResponse2004FundCountryDevelopment): [optional]  # noqa: E501
            regional_exposure (InlineResponse2004FundRegionalExposure): [optional]  # noqa: E501
            strategy (InlineResponse2004FundStrategy): [optional]  # noqa: E501
            industry (InlineResponse2004FundIndustry): [optional]  # noqa: E501
            srri (InlineResponse2004FundSrri): [optional]  # noqa: E501
            issuer (InlineResponse2004FundIssuer): [optional]  # noqa: E501
            assets_under_management (float): Assets under management (AUM).. [optional]  # noqa: E501
            compliance ([InlineResponse2004FundCompliance]): List of compliance properties to which the fund is compliant. See endpoint `/legalEntity/complianceProperty/list` for possible values.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
