"""
    Funds API For Digital Portals

    Search for mutual funds and ETFs using one single consolidated API, including a criteria-based screener. The API provides also base data, key figures, and holdings.  A separate endpoint returns the possible values and value range for the parameters that the endpoint /fund/notation/screener/search accepts: Application developers can request the values and value range only for a restricted set of notations that match predefined parameters. This functionality may be used to pre-fill the values and value ranges of the parameters of the /fund/notation/screener/search endpoint so that performing a search always leads to a non-empty set of notations.  This API is fully integrated with the corresponding Quotes API, allowing access to detailed price and performance information of instruments, as well as basic security identifier cross-reference. For direct access to price histories, please refer to the Time Series API for Digital Portals.  Similar criteria based screener APIs exist for equity instruments and securitized derivatives: See the Stocks API and the Securitized Derivatives API for details.  # noqa: E501

    The version of the OpenAPI document: 2
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FundsAPIforDigitalPortals.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FundsAPIforDigitalPortals.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_fund_compliance import InlineResponse2005DataFundCompliance
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_fund_currency import InlineResponse2005DataFundCurrency
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_fund_domicile import InlineResponse2005DataFundDomicile
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_share_class_assets_under_management import InlineResponse2005DataShareClassAssetsUnderManagement
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_share_class_distributing import InlineResponse2005DataShareClassDistributing
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_share_class_fee import InlineResponse2005DataShareClassFee
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_share_class_life_cycle import InlineResponse2005DataShareClassLifeCycle
    from fds.sdk.FundsAPIforDigitalPortals.model.inline_response2005_data_share_class_minimum_investment import InlineResponse2005DataShareClassMinimumInvestment
    globals()['InlineResponse2005DataFundCompliance'] = InlineResponse2005DataFundCompliance
    globals()['InlineResponse2005DataFundCurrency'] = InlineResponse2005DataFundCurrency
    globals()['InlineResponse2005DataFundDomicile'] = InlineResponse2005DataFundDomicile
    globals()['InlineResponse2005DataShareClassAssetsUnderManagement'] = InlineResponse2005DataShareClassAssetsUnderManagement
    globals()['InlineResponse2005DataShareClassDistributing'] = InlineResponse2005DataShareClassDistributing
    globals()['InlineResponse2005DataShareClassFee'] = InlineResponse2005DataShareClassFee
    globals()['InlineResponse2005DataShareClassLifeCycle'] = InlineResponse2005DataShareClassLifeCycle
    globals()['InlineResponse2005DataShareClassMinimumInvestment'] = InlineResponse2005DataShareClassMinimumInvestment


class InlineResponse2005DataShareClass(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'currency': ([InlineResponse2005DataFundCurrency],),  # noqa: E501
            'distributing': ([InlineResponse2005DataShareClassDistributing],),  # noqa: E501
            'registration_country': ([InlineResponse2005DataFundDomicile],),  # noqa: E501
            'life_cycle': (InlineResponse2005DataShareClassLifeCycle,),  # noqa: E501
            'minimum_investment': (InlineResponse2005DataShareClassMinimumInvestment,),  # noqa: E501
            'assets_under_management': (InlineResponse2005DataShareClassAssetsUnderManagement,),  # noqa: E501
            'compliance': ([InlineResponse2005DataFundCompliance],),  # noqa: E501
            'fee': (InlineResponse2005DataShareClassFee,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'currency': 'currency',  # noqa: E501
        'distributing': 'distributing',  # noqa: E501
        'registration_country': 'registrationCountry',  # noqa: E501
        'life_cycle': 'lifeCycle',  # noqa: E501
        'minimum_investment': 'minimumInvestment',  # noqa: E501
        'assets_under_management': 'assetsUnderManagement',  # noqa: E501
        'compliance': 'compliance',  # noqa: E501
        'fee': 'fee',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """InlineResponse2005DataShareClass - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            currency ([InlineResponse2005DataFundCurrency]): List of main currency identifiers. See endpoint `/basic/valueUnit/currency/main/list` for possible values.. [optional]  # noqa: E501
            distributing ([InlineResponse2005DataShareClassDistributing]): Indicates whether distributing (`true`) and non-distributing share classes (`false`) are among the results.. [optional]  # noqa: E501
            registration_country ([InlineResponse2005DataFundDomicile]): List of countries where the share classes have a trading registration. See endpoint `/basic/region/country/list` for possible values.. [optional]  # noqa: E501
            life_cycle (InlineResponse2005DataShareClassLifeCycle): [optional]  # noqa: E501
            minimum_investment (InlineResponse2005DataShareClassMinimumInvestment): [optional]  # noqa: E501
            assets_under_management (InlineResponse2005DataShareClassAssetsUnderManagement): [optional]  # noqa: E501
            compliance ([InlineResponse2005DataFundCompliance]): List of compliance properties for share classes. A given compliance property may appear in combination with other compliance properties. The attribute count represents the number of all occurences of a compliance property, that is in all existing combinations, whereby the latter are not listed separately. See endpoint `/instrument/complianceProperty/list` for the full list of compliance properties associated with instruments (across all asset classes).. [optional]  # noqa: E501
            fee (InlineResponse2005DataShareClassFee): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """InlineResponse2005DataShareClass - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            currency ([InlineResponse2005DataFundCurrency]): List of main currency identifiers. See endpoint `/basic/valueUnit/currency/main/list` for possible values.. [optional]  # noqa: E501
            distributing ([InlineResponse2005DataShareClassDistributing]): Indicates whether distributing (`true`) and non-distributing share classes (`false`) are among the results.. [optional]  # noqa: E501
            registration_country ([InlineResponse2005DataFundDomicile]): List of countries where the share classes have a trading registration. See endpoint `/basic/region/country/list` for possible values.. [optional]  # noqa: E501
            life_cycle (InlineResponse2005DataShareClassLifeCycle): [optional]  # noqa: E501
            minimum_investment (InlineResponse2005DataShareClassMinimumInvestment): [optional]  # noqa: E501
            assets_under_management (InlineResponse2005DataShareClassAssetsUnderManagement): [optional]  # noqa: E501
            compliance ([InlineResponse2005DataFundCompliance]): List of compliance properties for share classes. A given compliance property may appear in combination with other compliance properties. The attribute count represents the number of all occurences of a compliance property, that is in all existing combinations, whereby the latter are not listed separately. See endpoint `/instrument/complianceProperty/list` for the full list of compliance properties associated with instruments (across all asset classes).. [optional]  # noqa: E501
            fee (InlineResponse2005DataShareClassFee): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
